
#include "MHD.h"
#include "eno.h"

volume<int, 1> stencil [NDIR];
static volume<real, 1> ddiff;

#if INDICATOR == 1
// rho + B^2
real indicator(int i, int j, int k, int d)
{
  ConservedVars &Uijk = U[i][j][k];
  return Uijk.rho + Uijk.B.sqr();
}
#endif

void eno_calc_stencil()
{
  ddiff.reinit(NXl, NYl, NZl);
  for (int d = 0; d < NDIR; d++) {
    stencil[d].reinit(NXl, NYl, NZl);
    if (!HAVE_DIR(d)) continue;
    for (int i = -GX*DX[d]; i < NXl+DX[d]; i++) {
      for (int j = -GY*DY[d]; j < NYl+DY[d]; j++) {
	for (int k = -GZ*DZ[d]; k < NZl+DZ[d]; k++) {
	  real u1 = indicator(i, j, k, d);
	  real u2 = indicator(i+DX[d], j+DY[d], k+DZ[d], d);
	  ddiff[i][j][k] = fabs(u2 - u1);
	}
      }
    }
    for (int i = -DX[d]; i < NXl+DX[d]; i++) {
      for (int j = -DY[d]; j < NYl+DY[d]; j++) {
	for (int k = -DZ[d]; k < NZl+DZ[d]; k++) {
	  if (ddiff[i-DX[d]][j-DY[d]][k-DZ[d]] < ddiff[i][j][k])
	    stencil[d][i][j][k] = -1;
	  else
	    stencil[d][i][j][k] = 0;
	}
      }
    }
  }
}


