
#include "MHD.h"

///::title:: Cloud Shock 3d
///::vars:: NX=50 NY=50 NZ=50
///::consts:: MAXX=1 MAXY=1 MAXZ=1 MAXT=0.06
///::bc:: NEUMANN

void init_cell(PrimitiveVars &v, real x, real y, real z)
{
  if (x < 0.05) {
    v.rho = 3.86859;
    v.u[X] = 11.2536;
    v.B[Y] = 2.1826182;
    v.B[Z] = -2.1826182;
    v.p = 167.345;
  } else {
    if (sqr(x-0.25) + sqr(y-0.5) + sqr(z-0.5) <= 0.15*0.15)
      v.rho = 10.0;
    else
      v.rho = 1.0;
    v.B[Y] = 0.56418958;
    v.B[Z] = 0.56418958;
    v.p = 1.0;
  }
}
