
#include "MHD.h"

///::title:: Godunov-Powell Magnetic Advection
///::vars:: NX=512
///::consts:: MAXX=2.0 MAXT=1.0
///::consts:: N_UNIFORM=1 N_NORMAL=0
///::consts:: NO_POWELL=0
///::vars:: POWELL=1
///::bc:: REPEAT

void init_cell(PrimitiveVars &v, real x, real y, real z)
{
  x *= pi;
  
  real epsilon = 5e-2 * w.uniform[0];
  real freq    = 50;
  
  v.rho  = 1.0;
  v.u[X] = 1.0;
  v.u[Y] = 0.0;
  v.u[Z] = 0.0;
  v.B[X] = 1.0 - 0.5*sin(x) + epsilon*sin(freq*x);
  v.B[Y] = 0.5;
  v.B[Z] = 0.0;
  v.p    = 0.5;
}
