
#include "case.h"

///::title:: Second order Runge-Kutta timestepping

// u' = u + dt * u_t (u, t)
// u" = u' + dt * u_t (u', t+dt)
// u = (u + u")/2

static volume<ConservedVars, 0> save;

void time_step()
{
  //  dt = calc_time_step();
  //  if (t + dt > t1) dt = t1 - t;
  
  save.reinit(NXl, NYl, NZl);
  
  for (int i = 0; i < NXl; i++) {
    for (int j = 0; j < NYl; j++) {
      for (int k = 0; k < NZl; k++) {
	save[i][j][k] = U[i][j][k];
      }
    }
  }
  sub_step(true);

  step_init();
  sub_step(false);
  
  for (int i = 0; i < NXl; i++) {
    for (int j = 0; j < NYl; j++) {
      for (int k = 0; k < NZl; k++) {
	U[i][j][k] = 0.5 * (U[i][j][k] + save[i][j][k]);
      }
    }
  }
  t += dt;

  step_init();
}
