
#include "case.h"

///::title:: Third order Runge-Kutta timestepping

//....

static volume<ConservedVars, 0> save;

void time_step()
{
  //  dt = calc_time_step();
  //  if (t + dt > t1) dt = t1 - t;
  
  save.reinit(NXl, NYl, NZl);
  
  for (int i = 0; i < NXl; i++) {
    for (int j = 0; j < NYl; j++) {
      for (int k = 0; k < NZl; k++) {
	save[i][j][k] = U[i][j][k];
      }
    }
  }
  sub_step(true);

  step_init();

  sub_step(false);

  for (int i = 0; i < NXl; i++) {
    for (int j = 0; j < NYl; j++) {
      for (int k = 0; k < NZl; k++) {
	U[i][j][k] = 0.25 * (U[i][j][k] + 3 * save[i][j][k]);
      }
    }
  }

  step_init();

  sub_step(false);

  for (int i = 0; i < NXl; i++) {
    for (int j = 0; j < NYl; j++) {
      for (int k = 0; k < NZl; k++) {
	U[i][j][k] = (2*U[i][j][k] + save[i][j][k])/3;
      }
    }
  }

  t += dt;
  step_init();
}
